//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * キーボードヘッダ
 * @author Junpee
 */

#ifndef KEYBOARD_H_
#define KEYBOARD_H_

#include <Input/Keyboard/KeyboardKey.h>
#include <Input/Keyboard/KeyboardState.h>
#include <Input/Keyboard/KeyboardDevice.h>

namespace Lamp{

//------------------------------------------------------------------------------
/**
 * キーボード
 */
class Keyboard : public KeyboardKey{
friend class LampInput;
friend class BufferedInput;
public:
	//--------------------------------------------------------------------------
	/**
	 * キー数の取得
	 * @return キー数
	 */
	virtual int getKeyCount() const{ return device_->getButtonCount(); }

	/**
	 * キーが押されているか
	 * @param key 対象キー
	 * @return キーが押されていればtrue
	 */
	virtual bool pressed(Key key) const{ return state_.keyPressed(key); }

	/**
	 * キーが下がった
	 * @param key キー
	 * @return キーが下がったならばtrue
	 */
	virtual bool down(Key key) const{
		return (state_.keyPressed(key) && (!preState_.keyPressed(key)));
	}

	/**
	 * キーが上がった
	 * @param key キー
	 * @return キーが上がったならばtrue
	 */
	virtual bool up(Key key) const{
		return ((!state_.keyPressed(key)) && preState_.keyPressed(key));
	}

	//--------------------------------------------------------------------------
	/**
	 * 名前の取得
	 * @return 名前
	 */
	virtual String getName() const{ return device_->getProductName(); }

	/**
	 * アタッチされているか
	 * @return アタッチされていればtrue
	 */
	virtual bool isAttached() const{ return device_->isAttached(); }

	/**
	 * ポーリングが必要か
	 * @return ポーリングが必要ならtrue
	 */
	virtual bool isPolled() const{ return device_->isPolled(); }

	/**
	 * 文字列への変換
	 * @return 文字列
	 */
	virtual String toString() const;

	/**
	 * クリア
	 */
	virtual void clear(){
		state_.clear();
		preState_.clear();
	}

	/**
	 * 協調レベルの設定
	 * @param exclusive 排他モードならtrue
	 * @param foreground フォアグラウンドモードならtrue
	 * @return 成功すればtrue
	 */
	virtual bool setCooperativeLevel(bool exclusive, bool foreground){
		return device_->setCooperativeLevel(exclusive, foreground);
	}

	/**
	 * 排他モードか
	 * @return 排他モードならtrue
	 */
	virtual bool isExclusive() const{ return device_->isExclusive(); }

	/**
	 * フォアグラウンドモードか
	 * @return フォアグラウンドモードならtrue、バックグラウンドモードならfalse
	 */
	virtual bool isForeground() const{ return device_->isForeground(); }

protected:
	//--------------------------------------------------------------------------
	/**
	 * コンストラクタ
	 */
	Keyboard(KeyboardDevice* device);

	/**
	 * デストラクタ
	 */
	virtual ~Keyboard();

	/**
	 * 次のステート設定
	 * @param state 次のステート
	 */
	virtual void setNextState(const KeyboardState& state);

	/**
	 * ステートの取得
	 * @return ステート
	 */
	virtual const KeyboardState& getState(){ return state_; }

private:
	//--------------------------------------------------------------------------
	// デバイス
	KeyboardDevice* device_;
	// ステート
	KeyboardState state_;
	// 前回のステート
	KeyboardState preState_;
};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of KEYBOARD_H_
//------------------------------------------------------------------------------
